/*
 * changesys - Change the news 'sys' file entry of a system
 *	       Has to run as a suid - root program.
 *
 */

#ifdef SVR4		/* Define sysv if sysvr4 is defined */
#ifndef SYSV
#define SYSV
#endif
#endif
#if defined(__STDC__)
char *getaddr(char *string);
#else
char *getaddr();
#endif

#include <stdio.h>
#ifdef SVR4
#include <stdlib.h>	/* needed for malloc on sysvr4 */
#endif
#include <errno.h>
#include <pwd.h>
#include <grp.h>
#include <ctype.h>
#include <string.h>
#include <sys/types.h>
#include "config.h"

static char version[] = "changesys, version: 2.5, Jun 20, 1992";

/*
 * Unix style crypted password. Using this password you may change
 * anything, even machines not in changepwd.
 * JUM
 */
static char masterPassword[] = "dWatvzntI2HrM";

/*
 * panic
 *        something went wrong, unlock the news system and exit gracefully
 *	  9/27/91 MAM
 */
void panic(cause_of_panic)
int cause_of_panic;
{
	(void) newsunlock();
	exit (cause_of_panic);
}


/*
 * main
 */

main(argc, argv)
int argc;
char *argv[];
{
	char strtemp[SHORTBUF], mailtemp[SHORTBUF], *p;
	short int error=OK, setcont=0, errtmp;
	int reply_to = 0, header = 1;
	int mailToNewsRoot = 0;
	int echo;

	setids();		/* change ID's to news */
				/* Now we are user news */
	(void) newslock();		/* Lock the news system */

	*denystr= (char) 0;	/* Clear string for denied groups */
	*distline= (char) 0;	/* Clear string for distributions */
	numsys=NUMSYS;		/* number of groups per line */
	suspend=restore=0;

	strcpy(mailtemp, MAILTEMP); /* create a temp file for mail */
	(void) mktemp(mailtemp);
	if((fp = fopen(mailtemp,"w")) == NULL) {
		panic(RETFAIL); /* opening of mailtemp failed */
	}

	fprintf(fp, "Subject: Your latest changesys command\n\n");
	fprintf(fp, "%s\n\n", version),
	fprintf(fp, "This is how I received your mail:\n");
	fprintf(fp, "---------------------------------\n\n");

	while (fgets(buffer, BUFLEN, stdin) != NULL) {
		echo = 0;
		if((p=strchr(buffer, '\r')) != NULL) {
			*p = '\0';
			if((p=strchr(buffer, '\n')) == NULL) {
				strcat(buffer,"\n");
			}
		}
		if(buffer[strlen(buffer)-1] != '\n') {
			error = LONGLINE;
			break;
		}
		if(buffer[0] == '\n')		/* Mailheader ends */
			header=0;
		if (header && !reply_to && !strncmp(buffer, "From ", 5)) {
			sscanf(buffer, "%s %s", strtemp, returnpath);
			echo = 1;
		}
		if(strchr(buffer, ':')) {
			for(p=buffer; *p && (*p != ':'); p++) {
				if(isupper(*p))
					*p=tolower(*p);
			}
		}

		if (header && !reply_to) {
			if (!strncmp(buffer, "from:", 5) ||
			    !strncmp(buffer, "return-path:", 12) ||
			    !strncmp(buffer, "reply-to:", 9)) {
				echo = 1;
		  		p = getaddr(buffer);
	 			if (p) {
				  	strcpy(returnpath, p);
					free(p);
					if(!strncmp(buffer, "reply-to:", 9))
						reply_to=1;
				}
			}
		}
		if (!strncmp(buffer, "subject:", 8)) {
			echo = 1;
			sscanf(buffer, "%s %s", strtemp, subject);
			for(p=subject; *p; p++) {
				if(isupper(*p))
					*p=tolower(*p);
			}
		}
		if (!strncmp(buffer, "system:", 7)) {
			echo = 1;
			sscanf(buffer, "%s %s", strtemp, sysname);
		}
		if (!strncmp(buffer, "passwd:", 7)) {
			sscanf(buffer, "%s %s", strtemp, passwd);
		}
		if (!strncmp(buffer, "password:", 9)) {
			sscanf(buffer, "%s %s", strtemp, passwd);
			echo = 0;
		}
		if (!strncmp(buffer, "sysentry:", 9) || setcont) {
			echo = 1;
			if(!setcont) {
				for(p=strchr(buffer, ':')+1;(*p==' ' || *p=='\t');p++);
				strcpy(sysentry, p);
			}
			else {
				strcat(sysentry, buffer);
			}
			if (iscont()) {
				setcont=1;
				adjust();
			}
			else
				setcont=0;
		}
		if (echo)
			fprintf(fp, "> %s", buffer);
	}
	fprintf(fp, "\n\nThis is how I proccessed your mail:\n");
	fprintf(fp,     "-----------------------------------\n\n");

	if(!strlen(subject))
		error=error | NOSUBJECT;
	if(!strlen(sysname))
		error=error | NOSYSTEM;
	strcpy(sysname_orig, sysname);
	/*
	 * Only complete sysname with distribution if the user did
	 * not specify a distribution in its system: line.
	 */
	if (p = strchr(sysname_orig, '/'))
		*p = 0;
	else
		getsysname();
	getdeny();
	if(!strlen(passwd))
		error=error | NOPASSWD;
	if (!(!strcmp(subject,GETSYS) || !strcmp(subject, SETSYS) ||
	    !strcmp(subject, DELSYS) || !strcmp(subject, GETGROUPS) ||
	    !strcmp(subject, HELP) || !strcmp(subject, SUSPENDSYS) ||
	    !strcmp(subject, RESTORESYS) || !strcmp(subject, GETALL))) 
			error=error | WRONGSUBJECT;

	if(!strcmp(subject, SUSPENDSYS))
		suspend++;
	if(!strcmp(subject, RESTORESYS))
		restore++;
	if(!strcmp(subject, SETSYS)) {
		if(!strlen(sysentry))
			error=error | NOSYSENTRY;
		else {
			if(errtmp=checksysentry())
				error=error | errtmp;
		}
	}

	if(strcmp(subject, HELP)) {
		if(errtmp=checksys())
			error=error | errtmp;
	} else
		error = OK;

	if(error) {
		errmail(error);
		if (error & (WRONGPASSWD|UNKNOWNSYSTEM))
			mailToNewsRoot++;
	} else {
		if(!strcmp(subject, GETGROUPS))
			mailfile(ACTIVE);
		if(!strcmp(subject, SETSYS) || restore) {
			setsys();
			mailsys();
			mailToNewsRoot++;
		}
		if(!strcmp(subject, DELSYS) || suspend) {
			mailsys();
			delsys();
			mailToNewsRoot++;
		}
		if(!strcmp(subject, GETSYS) || !strcmp(subject, GETALL))
			mailsys();
		if(!strcmp(subject, HELP))
			mailfile(HELPFILE);
	}

	if(strlen(denystr)) {
		fprintf(fp, "\nNo permission for the following groups:\n\n");
		fprintf(fp, "%s\n", denystr);
	}
	if(strlen(NEEDEDGROUPS) && !strcmp(subject, SETSYS) && !error) {
		fprintf(fp, "\nYou will always get the following groups:\n\n");
		fprintf(fp, "%s\n", NEEDEDGROUPS);
	}
	fclose(fp);			/* Close mail temp file */
	strcpy(cmd, MAILER);
	/*
	 * Only mail interesting changes to the news admin.
	 */
	if (mailToNewsRoot) {
		strcat(cmd, " ");
		strcat(cmd, NEWSROOT);
	}
	strcat(cmd, " ");
	strcat(cmd, returnpath);
	strcat(cmd, " <");
	strcat(cmd, mailtemp);
	system(cmd);
	unlink(mailtemp);
	(void) newsunlock();		/* Unlock the news system */
	exit(RETOK);
}

/*
 * Scan a address data field, get all addresses seperated by ' '
 * Start scanning after the ':' of a from:, return-path: or reply-to:
 * ERNI 06/07/92
 * return a pointer to allocated machine-addresses
 *        NULL if something went wrong       
 */
char	*getaddr(addr_string)
char	*addr_string;
{
	char	*addr, *cpd, *this_addr;
	char	*cps;
	int	ignore = 0;

	addr_string=strchr(addr_string, ':') + 1;
	this_addr = cpd = addr = strdup(addr_string);
	if (addr == NULL) {
		return NULL;	/* Memory error */
	}
	for (cps = addr_string; *cps; cps++) {
		switch (*cps) {
		case '\t':
		case '\n':
		case '\r':
		case ' ':
			break;
		case '"':
			do {
				if (ignore) 
					cps++;
				else 
					*cpd++ = *cps++;
			} while (*cps && *cps != '"');
			if (!*cps) {		/* Address not correct, '"' missing */
				return NULL;	/* Parse error */
			}
			*cpd++ = '"';
			break;
		case '(': /* Comment */
			while (*cps && *cps != ')') 
				cps++;
			break;
		case ',':
			*cpd++ = ' ';
			this_addr = cpd;
			ignore = 0;
			break;
		case '<':			/* Machine parsable Address */
			cpd = this_addr;		/* Ignore the other stuff */
			cps++;
			do {
				*cpd++ = *cps++;
			} while (*cps && *cps != '>');
			if (!*cps) {		/* Address not correct, '>' missing */
				return NULL;	/* Parse error */
			}
			*cpd = 0;
			ignore = 1;
			break;
		default:
			if (!ignore) 
				*cpd++ = *cps;
			break;
		}
	}
	*cpd = 0;			/* Terminate string */
	return addr;
}

/*
 * iscont - Return 1 if buffer ends with '\'
 *
 */
iscont()
{
	if ((int)strlen(buffer) < 2)
		return 0;		/* Can't end with \ */

	if (buffer[strlen(buffer)-2] == '\\')
		return 1;
	else
		return 0;
}

/*
 * Make sure that continuing sysentry lines end with the string
 * ,\ (no spaces between the , and the \)
 *
 */
adjust()
{
	char *p;

	p = strrchr(sysentry, '\\');

	p--;
	while((*p == ' ') || (*p == '\t'))
			p--;
	if(*p != ',')
		p++;
	*p = '\0';
	strcat(sysentry, ",\\\n");
}

/*
 * Return the postion of a character in a string.
 *
 */
pos(str, ch)
char *str, ch;
{
	int p;
	for(p=0; *str && (*str != ch); p++,str++);
	return (p);
}

/*
 * Return 1 if str1 contains any of the characters of str2
 *
 */
has_char(str1, str2)
char *str1, *str2;
{
	char *i;

	for(i=str2; *i; i++) {
		if(strchr(str1, *i))
			return (1);
	}
	return(0);
}

getsysname()
{
	FILE *fp;
	char sys1[SHORTBUF], sys2[SHORTBUF];
	char *p;

	if((fp=fopen(SYSFILE, "r")) == NULL)
		return(0);

	strcpy(sys1, sysname);
	strcat(sys1, ":");
	strcpy(sys2, sysname);
	strcat(sys2, "/");
	while(fgets(buffer, BUFLEN, fp) != NULL) {
		if(!strncmp(buffer, sys1, strlen(sys1)) ||
		   !strncmp(buffer, sys2, strlen(sys2))) {
			p = strtok(buffer, ":");
			strcpy(sysname, p);
#ifdef CNEWS
			buffer[strlen(buffer)] = ':';
			if (iscont()) {
				while((fgets(buffer, BUFLEN, fp) != NULL) &&
					iscont())
					;
			}
			if((p = strrchr(buffer,'/'))) {
				strcpy(distline,p);
			}
#endif
			break;
		}
	}
	fclose(fp);
	return(0);
}

checksysentry()
{
	int world = 0, hastosys = 0, badchars=0;
	char systemp[SHORTBUF], *p, *q;

	/*
	 * Delete spaces and tabs from the sysentry string
	 */
	for(p=sysentry,q=buffer;*p;p++) {
		while(*p==' ' || *p=='\t') {
			p++;
			continue;
		}
		*q=*p;
		q++;
	}
	*q='\0';
	strcpy(sysentry,buffer);

	if(has_char(sysentry, ":;#'~*{}[]()/&%$^<>|\""))
		return (BADSYSCHARS);

	strcpy(systemp, "to.");
	strcat(systemp, sysname_orig);
	strcpy(buffer, sysentry);
	*sysentry= (char) 0;
	for(p=strtok(buffer, ",/\\\n"); p; p=strtok(NULL, ",/\\\n")) {
#ifdef DEBUG
printf ("entry: <%s>\n",p);
#endif
		if(!strcmp(p, systemp))
			hastosys=1;
		if(!strcmp(p, "world"))
			world = 1;
		if(!isdeny(p)) {
			if(!numsys) {
				strcat(sysentry, "\\\n");
				numsys=NUMSYS;
			}
			strcat(sysentry, p);
			strcat(sysentry, ",");
			numsys--;
		}
		else {
			strcat(denystr, p);
			strcat(denystr, ",");
		}
	}
#ifdef DEBUG
	printf ("end of loop\n");
#endif
	/* Stripp off trailing ',' */
	if (*denystr) denystr[strlen(denystr)-1]='\0';
	if (!*denyline) {
		if (*sysentry)
			sysentry[strlen(sysentry)-1]='\0';
	} else
		strcat(sysentry, "\\\n");
	strcat(sysentry,denyline);
	strcpy(buffer, sysname);

#ifdef CNEWS
	strcat(buffer, ":\\\n");
	if(strlen(NEEDEDGROUPS)) {
		strcat(buffer, NEEDEDGROUPS);
		if (strlen(sysentry))
			strcat(buffer, ",\\\n");
	}
	strcat(buffer, sysentry);
	strcat(buffer, "\\\n");
	if(strlen(distline))
		strcat(buffer,distline);
	else
		strcat(buffer, DEFAULTDIST);
#else /* BNEWS */
	if(world)
		strcat(buffer, ":");
	else
	/*	strcat(buffer, ":world,"); */
		strcat(buffer, ":");
	strcat(buffer, "\\\n");
	if(strlen(NEEDEDGROUPS)) {
		strcat(buffer, NEEDEDGROUPS);
		strcat(buffer, ",");
	}
	strcat(buffer, sysentry);
	if(!hastosys) {
		strcat(buffer, ",\\\n");
		strcat(buffer, sysname_orig); 
		strcat(buffer, "/all,!local");
	}
	strcat(buffer, ":F:\n");
#endif /* BNEWS */
	strcpy(sysentry, buffer);

#ifdef DEBUG
	printf("sysentry=\n%s\n",sysentry);
#endif
	return (0);
}

/*
 * Mail a file to the remote system
 *
 */
mailfile(fname)
char *fname;
{
	FILE *af;
	char buffer[SHORTBUF];

	if((af=fopen(fname, "r")) == NULL)
		return(0);

	while(fgets(buffer, SHORTBUF, af) != NULL)
		fputs(buffer, fp);
	fclose(af);
	return (0);
}

setsys()
{
	FILE *fptr;

	*suspendstr=(char) 0;
	if(restore) {
		strcpy(suspendedfile, SUSPENDDIR);
		strcat(suspendedfile, "/");
		strcat(suspendedfile, sysname_orig);
		if((fptr=fopen(suspendedfile, "r")) == NULL) {
			fprintf(fp, "No suspend file to restore from.\n\n");
			return(0);
		}

		while(fgets(buffer, BUFLEN, fptr) != NULL) {
			strcat(suspendstr, buffer);
		}
		fclose(fptr);
		unlink(suspendedfile);
		if(!*suspendstr) {
			fprintf(fp, "Suspend file was empty.\n\n");
			return(0);
		}
	}

	/* Delete sys file entry first and add the new
	   entry afterwards
	*/
	if (!delsys()) return (0);

	if((fptr=fopen(SYSFILE, "a")) == NULL)
		return(0);

	fprintf(fptr,"#\n# System: %s\n#\n", sysname_orig);
	if(*suspendstr && restore)
		fprintf(fptr, "%s", suspendstr);
	else
		fprintf(fptr, "%s", sysentry);

	fclose(fptr);
	return (0);
}

delsys()
{
	FILE *fptr, *tp, *sfp;
	char temp[SHORTBUF], sys[SHORTBUF], system[SHORTBUF];
	int validentry=0;
	char *p, *q;

	strcpy(temp, CHANGETEMP);
	(void) mktemp(temp);
	if((tp = fopen(temp, "w")) == NULL)
		return(0);

	if((fptr=fopen(SYSFILE, "r")) == NULL)
		return(0);

	while(fgets(buffer, BUFLEN, fptr) != NULL) {
		if(*buffer == '#' || *buffer=='\n')
			continue;
		p = buffer;
		q = sys;
		while (*p && *p != '/' && *p != ':')
			*q++ = *p++;
		*q = 0;
		if(!strcmp(sys, sysname_orig)) {
			validentry++;
			strcpy(suspendstr, buffer);
			if (iscont()) {
				while((fgets(buffer, BUFLEN, fptr) != NULL) &&
					iscont()) {
						strcat(suspendstr, buffer);
				}
				strcat(suspendstr, buffer);
			}
		}
		else {
			strcpy(system,buffer);
			system[pos(buffer,':')] = '\0';
			if(strchr(system,'/'))
				system[pos(buffer,'/')] = '\0';
			fprintf(tp, "#\n# System: %s\n#\n", system);
			fprintf(tp, "%s", buffer);
			if (iscont()) {
				while((fgets(buffer, BUFLEN, fptr) != NULL) &&
					iscont()) {
						fprintf(tp, "%s", buffer);
				}
				fprintf(tp, "%s", buffer);
			}
		}
	}
	fclose(fptr);
	fclose(tp);
	unlink(SYSFILE);
	link(temp, SYSFILE);
	unlink(temp);
	if(suspend && validentry) {
		strcpy(suspendedfile, SUSPENDDIR);
		strcat(suspendedfile, "/");
		strcat(suspendedfile, sysname_orig);
		if((sfp=fopen(suspendedfile, "w")) == NULL)
			return(0);
		fprintf(sfp, "%s", suspendstr);
		fclose(sfp);
		fprintf(fp, "\nYour sys file entry has been deleted.\n");
		fprintf(fp, "Use restoresys to undo the deletion.\n\n");
	}

	return (1);

}

/*
 * Mail the latest sys file entry to the remote user
 *
 */
mailsys()
{
	FILE *sf;
	char sys[SHORTBUF];
	int found=0;
	char *p, *q;

	if((sf=fopen(SYSFILE, "r")) == NULL)
		return(0);

	fprintf(fp, "This is your latest sys file entry:\n\n");
	while(fgets(buffer, BUFLEN, sf) != NULL) {
		if(*buffer == '#' || *buffer=='\n')
			continue;
		p = buffer;
		q = sys;
		while (*p && *p != '/' && *p != ':')
			*q++ = *p++;
		*q = 0;
		if(!strcmp(sys, sysname_orig)) {
			found=1;
			fprintf(fp,"#\n# System: %s\n#\n", sysname_orig);
			fprintf(fp, "%s", buffer);
			if (iscont()) {
				while((fgets(buffer, BUFLEN, sf) != NULL) &&
					iscont())
					fprintf(fp, "%s", buffer);
				fprintf(fp, "%s", buffer);
			}
#ifdef CNEWS		/* Print all resulting newsgroups */
			if(strlen(PIPECMD) && !strcmp(subject, GETALL)) {

				char buf[BUFSIZ];
				char *pipe_cmd;
				FILE *pipe;

				pipe_cmd=(char*) malloc(strlen(PIPECMD) + strlen(sysname_orig));
				sprintf(pipe_cmd,PIPECMD,sysname_orig);
				if( (pipe=popen(pipe_cmd,"r")) != NULL) {
					fprintf(fp,"\nYou will receive the following newsgroups:\n\n");
					while(fgets(buf,BUFSIZ,pipe) != NULL)
						fputs(buf,fp);
	 				close(pipe);
				}
				free(pipe_cmd);
			}
#endif
		}
	}
	if(!found)
		fprintf(fp, "No sys file entry for your system\n\n");
	fclose(sf);
	return(0);
}

/*
 * Mail error messages to the remote user
 *
 */
errmail(error)
short int error;
{

	fprintf(fp, "Dear newsuser,\n\n");
	fprintf(fp, "your request could not be completed due to the following errors:\n\n");

	if(error & NOSUBJECT)
		fprintf(fp, "No subject line for commands\n");
	if(error & NOSYSTEM)
		fprintf(fp, "System line is missing\n");
	if(error & NOPASSWD)
		fprintf(fp, "Password line is missing\n");
	if(error & WRONGPASSWD)
		fprintf(fp, "Password is not valid for given system\n");
	if(error & WRONGSUBJECT)
		fprintf(fp, "No valid command in subject line\n");
	if(error & NOSYSENTRY)
		fprintf(fp, "Sysentry line is missing\n");
	if(error & UNKNOWNSYSTEM)
		fprintf(fp, "I don't know your system\n");
	if(error & BADSYSCHARS)
		fprintf(fp, "Bad characters in sysentry string\n");
	if(error & LONGLINE)
		fprintf(fp, "A line was too long for me to handle\n");
	fprintf(fp, "\nPlease try again with 'help' as the subject.\n");
	fprintf(fp, "You will get a help file mailed back to you.\n");
}

/*
 * Check the password file for remote user
 *
 */
checksys()
{
	FILE *fp;
	char buf[SHORTBUF], sy[SHORTBUF], pw[SHORTBUF], re[SHORTBUF];
	int error=UNKNOWNSYSTEM;

	/*
	 * JUM: check for master password. If this is used,
	 *	the system must not be listed in the passwd file.
	 */
	if(strcmp(crypt(passwd, masterPassword), masterPassword) == 0)
		return OK;

	if ((fp=fopen(PWORDFILE, "r")) == NULL) {
		return(error);
	}

	while(fgets(buf, SHORTBUF, fp) != NULL) {

		*sy=*pw=*re=(char) 0;

		if( sscanf(buf, "%s %s %s", sy, pw, re) < 2) 
			continue;	/* wrong format, don't bother me with this */
		if(!strlen(sy))
			continue;	/* skip empty lines */
		if(*sy == '#')
			continue;	/* skip comments */
		if(!strcmp(sy,sysname_orig))
			if(strcmp(crypt(passwd, pw), pw) == 0) {
				error=OK;
				if(strlen(re))
					strcpy(returnpath,re);
				break;
			}
			else
				error=WRONGPASSWD;
	}

	fclose(fp);
	return (error);
}

/*
 * Get the deny line.
 *
 */
getdeny()
{
	FILE *fp;
	char buf[MEDBUF], sy[SHORTBUF];

	if ((fp=fopen(DENYFILE, "r")) == NULL) {
		return(0);
	}

	while(fgets(buf, MEDBUF, fp) != NULL) {
		*sy=*denyline=(char) 0;
		sscanf(buf, "%s %s", sy, denyline);
		if(!strlen(sy))
			continue;	/* skip empty lines */
		if(*sy == '#') {
			*denyline = (char) 0;
			continue;	/* skip comments */
		}
		if(!strcmp(sy,sysname_orig))
				break;
		*denyline= (char) 0;
	}
	if(!strlen(denyline))
		strcpy(denyline, DEFAULTDENY);

	fclose(fp);
	return (0);
}

/*
 * isdeny - Return 1 if token is part of the deny list
 */
isdeny(group)
char *group;
{
	char *p, *p1, *p2;
	int ret;

	ret=0;
#ifdef DEBUG
	printf ("isdeny: denyline=<%s>\n",denyline);
#endif
/*
 * MAM 9/27/91
 * MAJOR BUG! first check if there is something to do, or the following
 *            malloc will hang forever!
 */
	if (!*denyline) return 0; /* nothing there, nothing to check */

	p1=malloc(strlen(denyline)+1);
	strcpy(p1,denyline);
	p=p1+1;
	while((p2=strchr(p,','))) {
		*p2 = '\0';
		if(founddeny(group,p))
			ret=1;
		p=p2+2;
	}
	if(founddeny(group,p))
		ret=1;
	free(p1);
	return(ret);
}

founddeny(group,deny)
char *group,*deny;
{

	register int deny_len;

	deny_len=strlen(deny);

	if( deny_len > (int) strlen(group))
		return(0);		/* Deny longer than group */
	if(!strcmp(group,deny))
		return(1);		/* Both are equal */
	if(strchr(group, '.'))
		if(!strncmp(group,deny,deny_len))
			if(group[deny_len] == '.')
				return(1);
	return(0);
}

/*
 * Set user id's
 *
 */
setids()			/* change ID's */
{
	int newsuid, newsgid;
	struct group *getgrnam();
	register struct passwd *pwp;
	register struct group *grp;

	pwp = getpwnam(NEWSOWNER);
	if (pwp != NULL) {
		newsuid = pwp->pw_uid;
		newsgid = pwp->pw_gid;
	}
	(void) endpwent();
	grp = getgrnam(NEWSGROUP);
	if (grp != NULL)
		newsgid = grp->gr_gid;
	(void) endgrent();
	if (setgid(newsgid) < 0 || setuid(newsuid) < 0 ||
	    getgid() != newsgid || getuid() != newsuid) {
		panic(RETFAIL); /* Give up */
	}
}


/*
 * Lock the news system.
 * A File LOCKTEMP with the pid of the current process will be created.
 * Then we try to rename LOCKTEMP to LOCKNAME.
 *
 * MAM 12/5/90
 * Added kill(pid,0) for SYSV to check out if locking task is still alive.
 * On crashexits this (and other programs) keep the lockfile on disk which
 * can be assumed a bad habit.
 */

newslock()
{
	char tempnm[SHORTBUF], lockfile[SHORTBUF];
	FILE *tempfp;
#ifdef SYSV
	int pid;
#endif

	strcpy(tempnm, LOCKTEMP);
	(void) mktemp(tempnm);
	tempfp = fopen(tempnm, "w");
	if (tempfp == NULL)
		exit(RETFAIL);		/* Give up */
	(void) fprintf(tempfp, "%10d\n", getpid());
	(void) fclose(tempfp);

	strcpy(lockfile, LOCKNAME);
	while (link(tempnm, lockfile) < 0) {
		if (errno != EEXIST) {
			unlink(tempnm);
			exit(RETFAIL);	/* Give up */
		}
#ifdef SYSV
	/* on SYSV we can use kill(pid,0) to check out existance of task */
		if (tempfp=fopen(lockfile,"r")) {
			fscanf(tempfp,"%d",&pid);
			fclose(tempfp);
			if (kill(pid,0) && errno==ESRCH) {
				if (unlink(lockfile)) {
					unlink(tempnm);
					exit (RETFAIL); /* Give up */
				}
			}
		} else	{
			unlink(tempnm);
			exit(RETFAIL); /* Give up */
		}
#endif
		sleep(INTERVAL);
	}
	(void) unlink(tempnm);
}

newsunlock()
{
	(void) unlink(LOCKNAME);
}

crypt(s1,s2)
char *s1,*s2;
{
strncpy(s1,s1,64);
}
