/*
 * cryptpw: Encrypt a password Unix style.
 *
 * JUM 19-Jun-1993
 */
#include <stdio.h>
#include <sys/types.h>

main(argc, argv)
int argc;
char **argv;
{
	time_t now;
	char *l64a();

	if (argc != 2) {
		fprintf(stderr, "Usage: %s key\n", argv[0]);
		exit(1);
	}
	time(&now);
	printf("%s\n", crypt(argv[1], l64a(now)));
	exit(0);
}

/*
 * convert long int to base 64 ascii
 * char set is [./0-9A-Za-z]
 * two's complement negatives are assumed,
 * but no assumptions are made about sign propagation on right shift
 *
 */

#define BITSPERBYTE	8
#define BITSPERCHAR	6 /* to hold entire character set */
#define BITSPERLONG	(BITSPERBYTE * sizeof(long))
#define NMAX	((BITSPERLONG + BITSPERCHAR - 1)/BITSPERCHAR)
#define SIGN	(-(1L << (BITSPERLONG - BITSPERCHAR - 1)))
#define CHARMASK	((1 << BITSPERCHAR) - 1)
#define WORDMASK	((1L << ((NMAX - 1) * BITSPERCHAR)) - 1)

static char buf[NMAX + 1];

char *
l64a(lg)
register long lg;
{
	register char *s = buf;

	while (lg != 0) {

		register int c = ((int)lg & CHARMASK) + ('0' - 2);

		if (c > '9')
			c += 'A' - '9' - 1;
		if (c > 'Z')
			c += 'a' - 'Z' - 1;
		*s++ = c;
		/* fill high-order CHAR if negative */
		/* but suppress sign propagation */
		lg = ((lg < 0) ? (lg >> BITSPERCHAR) | SIGN :
			lg >> BITSPERCHAR) & WORDMASK;
	}
	*s = '\0';
	return (buf);
}

crypt(d1,d2)
char *d1,*d2;
{
strncpy(d1,d1,64);
}
