#!/usr/bin/perl
eval "exec /usr/local/bin/perl -S $0 $@"
	if $exec_by_shell;
#
# Monitor /var/uucp/.Status for all all systems of the news
# sys file and send a suspendsys message to changesys for all
# systems which didn't poll since $numdays.
#
# You have to make sure that uucleanup isn't running too often ...
#
# Usage: suspendsys [-n] [-m] [system ...]
#                    -n        Delete already spooled news
#                    -m        Delete already spooled mail
#                    system    Do it for a specific system
#                              unconditionally.
#
# The -n and -m option only differentiate between news, mail and the
# rest, on systems with uucp grading.
#
# $Id: suspendsys.pl,v 1.5 1992/05/31 17:10:37 root Exp root $
#
# HERE COMES THE VARIABLES

require ('getopt.pl');
do Getopt('');
$delnews = defined $grading && defined $opt_n ? 1 : 0;
$delmail = defined $grading && defined $opt_m ? 1 : 0;
$cnews = defined $cnews && defined $opt_n ? 1 : 0;

if(@ARGV < 1) {
	@ARGV = &getsys();
}

#
# Send a suspendsys Message to changesys for all systems of the array
# @ARGV. Ignore systems, which are not in the changepwd file.
#
foreach $system(@ARGV) {

	open(SYSPWD, $changepwd);
	while(<SYSPWD>) {
		($sys,$passwd,$user) = split(/ /, $_);
		last if ($system eq $sys);
	}
	close(SYSPWD);
	next if($system ne $sys);	# Do nothing if system not in changepwd

	$gradesys=substr($system,0,$gsyslen);
	$uucpspool = $uucpspool . "/" . $system;
	if ($grading) {
		if ($delnews && $svr4grade) {
			push (@deldirs, $uucpspool . "/" . $newsgrade);
		}
		if ($delmail && $svr4grade) {
			push (@deldirs, $uucpspool . "/" . $mailgrade);
		}
		if (!$svr4grade) {
			push (@deldirs, $uucpspool);
		}
	} else {
		if (defined $opt_n || defined $opt_m) {
			push (@deldirs, $uucpspool);
		}
	}
	if ($cnews && defined $opt_n) {
		push (@deldirs, $outdir . "/" . $system);
	}
	foreach $dir (@deldirs) {
		chdir("$dir") || next;	# Ignore non existant directories
		opendir(DIR,".") || die "Couldn't open directory $dir\n";
		@files = readdir(DIR);
		closedir(DIR);
		foreach (@files) {
			next if -d;		# Skip Directories
			if(!$grading||($cnews&&$dir=~/^$outdir/)) {
				push (@delfiles, $_);
			} else {		# Handle news grading
				if ($delnews) {
					if(/^C.$gradesys$newsgrade/) {
						push (@delfiles, $_);
						open(FILE, $_);
						$_=<FILE>;
						($junk, $file) = split(/ /, $_);
						push (@delfiles, $file);
						$_=<FILE>;
						($junk, $file) = split(/ /, $_);
						push (@delfiles, $file);
						close (FILE);
					}
				}
				if ($delmail) {
					if(/^C.$gradesys$mailgrade/) {
						push (@delfiles, $_);
						open(FILE, $_);
						$_=<FILE>;
						($junk, $file) = split(/ /, $_);
						push (@delfiles, $file);
						$_=<FILE>;
						($junk, $file) = split(/ /, $_);
						push (@delfiles, $file);
						close (FILE);
					}
				}
			}
		}
		unlink(@delfiles);
		undef @delfiles;
	}

	open(MAILER, "|$mailer changesys")
		|| die "Can't open pipe to $mailer\n";
	print MAILER "Subject: suspendsys\n\n";
	print MAILER "Dear Newsuser,\n\n";
	print MAILER "You havn't polled my system since over $numdays days.\n";
	print MAILER "As a result of this, I have suspended your sys file\n";
	print MAILER "Entry. You can restore your sys file entry with the\n";
	print MAILER "restoresys command.\n\n";
	if(defined $opt_n || defined $opt_m) {
		if(defined $opt_n && !defined $opt_m) {
			print MAILER "News";
		}
		if(defined $opt_m && !defined $opt_n) {
			print MAILER "Mail";
		}
		if(defined $opt_m && defined $opt_n) {
			print MAILER "News and mail";
		}
		print MAILER " for you was also deleted.\n\n";
	}
	print MAILER "system: $system\n";
	print MAILER "passwd: $passwd\n";
	close(MAILER);
}
exit 0;

#
# Return all systems of $sysfile which havn't polled since
# $numdays days.
#
sub getsys {
    
    local($system,$rest,$slash,@sys);
    local($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size);
    local($atime,$mtime,$ctime,$blksize,$blocks,@suspend);
    
    open(SYSFILE, $sysfile) || die "Can't open sys file\n";
    while(<SYSFILE>) {
    	next if /^$/;		# Skip empty lines
    	next if /^#/;		# Skip comment lines
    	chop;
    	($system, $rest)=split(/:/, $_);
    	$slash=index($system, "/");
    	if($slash > 0) {
    		$system = substr($system,0,$slash);
    	}
    	while(index($_, "\\") > 0) {	# Skip over continuation lines
    		$_=<SYSFILE>;
    	}
    	push(@sys, $system);
    }
    close(SYSFILE);
    
    #
    # Check files in $uucpstat for every system in @sys
    # and put all files which havn't been modified since $numday
    # days into the array @suspend.
    #
    foreach $system(@sys) {
    	($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,
    	$mtime,$ctime,$blksize,$blocks) = stat("$uucpstat/$system");
    
    	if((time - $mtime) > ($numdays * 86400)) {
    		push(@suspend, $system);
    	}
    }
    return @suspend;
}
